; part by gerliczer for Crackers' Demo 5
; (a plus/4 scene community effort)
; for rok Party in 2016
; programmed during the 2016-05-15..2016-06-13 period
; with a GIGANTIC help from Csabo in sound effect
; programming (PAL/NTSC tempo difference remains)
; created with Csabo's Plus4IDE 1.70 and
; Frank A. Kingswood's AS65 1.42
; upload only to strictly CBM264 series related sites
; PAL&NTSC compatible program, 64kB memory required
; final cosmetic changes on 2016-07-22
; last minute NTSC compatibility fix on 2016-07-28

	org $1001-2
	dw  $1001
	
	dw nextln, 2016	; second word is line number
	db $9E
	if start > 9999
	db "0"+start/10000
	endif
	db "0"+(start/1000)%10,"0"+(start/100)%10,"0"+(start/10)%10,"0"+start%10,0
nextln	db 0,0

dsrc	equ $d8
ddir	equ $d9
addy	equ $da
addy_l	equ addy
addy_h	equ addy+1
wave_qm	equ $dc
swipe_c	equ $dd
scroll	equ $de
ntsc	equ $df
digistp	equ $e0
scrostp	equ $e1
ten	equ $e2

start	sei
	jsr chkTV
	jsr F30B	; reset TED registers
;	lda $ff80	; PAL/NTSC detection from ROM
;	sta ntsc	; version identifier
	lda #0
;	sta $ff19	; start in the "dark"
	lda $ff06
	and #%11101111
	sta $ff06
	lda #0
	sta $ff11
	lda #$fd        ; muting sound generators
	sta $ff0e
	lda #$fe
	sta $ff0f
	lda #3
	sta $ff10
	lda $ff12
	ora #3
	sta $ff12
	lda $ff07	; set 256 characters mode
	ora #$80
	sta $ff07
	lda $ff12	; set chargen to RAM
	and #%11111011
	sta $ff12
	lda $ff13	; set chargen origin
	and #%00000011
	ora #hi(charset)
	sta $ff13
	ldx #$04	; Number of pages
	ldy #$08	; Hi byte of address ($0800)
	lda #$00	; Byte to fill
	jsr $C5A7
	ldx #$04	; This clears the screen
	ldy #$0C	; Hi byte of address $0C00
	lda #$FF	; $FF character
	jsr $C5A7
	lda #$ff	; move cursor out of screen
	sta $ff0c
	sta $ff0d
	lda #0		; reset interrupts
	sta $ff0a
	asl $ff09
	sta swipe_c	; setting up control variables
	sta scroll
	sta digistp
	sta scrostp
	sta dsrc
	sta ddir
	lda $ff06
	ora #$10
	sta $ff06
	lda ntsc
	bmi pal_
	lda #12
	db $2c		; BIT skip
pal_	lda #10
	sta ten
	jsr characterDownSwipe
	ldx #$04	; Number of pages
	ldy #$08	; Hi byte of address ($0800)
	lda #$71	; Byte to fill
	jsr $C5A7
	jsr copyWaveData; setting up screen
	jsr copyLogoData
	sta $ff3f	; setup timer interrupt
	lda #lo(irq)	; to play digitized speech
	sta $fffe
	lda #hi(irq)
	sta $ffff
	lda $ff0a
	ora #$08
	sta $ff0a
	ldy ntsc	; TV system check
	bmi pal
	lda #$e4
	sta $ff00	; NTSC/PAL sync
	bne both
pal	lda #$e2
	sta $ff00
both	lda #0
	sta $ff01
	sta swipe_c
	cli
	jsr backgroundUpSwipe
loop00	jsr waitF0	; playing animation
	jsr copyWaveData
	jsr controlCopyUpdate
	jsr updateCopyWave
	jsr waitF0
	jsr scrollIntroduction
	jsr updateScroll
	lda digistp	; checking exit conditions
	beq skip000
	lda scroll
	cmp #40
	bcc skip000
killirp	jsr irqReprogram
	lda #$2c
	sta killirp
skip000	lda scrostp
	beq loop00
	lda #0
	sta swipe_c
	jsr backgroundDownSwipe
	jsr waitF0
	sei		; stopping sound & irq
	lda #0
	sta $ff0a
	sta $ff11
	asl $ff09
	sta $ff3e
	ldx #$04	; Number of pages
	ldy #$0C	; Hi byte of address ($0C00)
	lda #$00	; Byte to fill
	jsr $C5A7
	ldx #$04	; Number of pages
	ldy #$08	; Hi byte of address ($0800)
	lda #$00	; Byte to fill
	jsr $C5A7
	lda #0
	sta swipe_c
	jsr characterUpSwipe
	lda $ff06	; screen off while clearing
	and #%11101111
	sta $ff06
	ldx #$04	; Number of pages
	ldy #$0C	; Hi byte of address ($0C00)
	lda #$00	; Byte to fill
	jsr $C5A7
	ldx #$20	; Number of pages
	ldy #hi(bmpdst)	; Hi byte of address
	lda #$00	; Byte to fill
	jsr $C5A7
	jsr waitF0
	lda $ff06	; setting MC gfx mode
	ora #$30
	sta $ff06
	lda $ff07
	ora #$10
	sta $ff07
	lda $ff12
	and #%11000111
	ora #(hi(bmpdst))>>2
	sta $ff12
	sta $ff3f
	lda #0		; setting common colours and
	sta ch1+1	; "sound fx" parameters
	sta ch2+1
	sta $ff15
	lda #$71
	sta $ff16
	lda ntsc	; setting up sound tables
	bmi pal2	; for TV system
	lda #lo(ntscfrq)
	sta frq01+1
	sta frq02+1
	sta frq03+1
	sta frq04+1
	lda #hi(ntscfrq)
	sta frq01+2
	sta frq02+2
	sta frq03+2
	sta frq04+2
	bne setirq2
pal2	lda #lo(palfrq)
	sta frq01+1
	sta frq02+1
	sta frq03+1
	sta frq04+1
	lda #hi(palfrq)
	sta frq01+2
	sta frq02+2
	sta frq03+2
	sta frq04+2
setirq2	lda #lo(irq2)	; setting and starting
	sta $fffe	; "sound fx" interrupt
	lda #hi(irq2)
	sta $ffff
	lda #$d0
	sta $ff0b
	lda #2
	sta $ff0a
	lda #$34
	sta $ff11
	cli
	jsr paintLogoLines
	ldx #5		; holding logo on screen
	ldy #201
	jsr waitF0
	dey
	bne *-4
	dex
	bne *-10
	jsr clearLogoLines
	sei		; cleanup
	lda #0
	sta $ff0a
	asl $ff09
	sta $ff3e
	cli
	jsr F30B
	lda #0
;	sta $ff19
	sta $ff06
	ldx #$04	; Number of pages
	ldy #$08	; Hi byte of address ($0800)
	lda #$00	; Byte to fill
	jsr $C5A7
	ldx #$04	; This clears the screen
	ldy #$0C	; Hi byte of address $0C00
	lda #$20	; $20 character
	jsr $C5A7
	lda $500	; checking if run standalone
	cmp #$ea 	; or in the co-op demo 
	beq democtr
	jmp $fff6
democtr	jmp $500        ; handing over control

;-------------------------------------------------------
; this waits for raster line $f0
waitF0	lda #$f0
	cmp $ff1d
	bne *-3
	rts
;-------------------------------------------------------
; this copies 15 rows of 32 character length data to the
; bottom left of the default screen character matrix
;
copyWaveData
	ldx #31
loop01
smc01	lda label1+ 0*32,x
	sta $d90,x
smc02	lda label1+ 1*32,x
	sta $db8,x
smc03	lda label1+ 2*32,x
	sta $de0,x
smc04	lda label1+ 3*32,x
	sta $e08,x
smc05	lda label1+ 4*32,x
	sta $e30,x
smc06	lda label1+ 5*32,x
	sta $e58,x
smc07	lda label1+ 6*32,x
	sta $e80,x
smc08	lda label1+ 7*32,x
	sta $ea8,x
smc09	lda label1+ 8*32,x
	sta $ed0,x
smc10	lda label1+ 9*32,x
	sta $ef8,x
smc11	lda label1+10*32,x
	sta $f20,x
smc12	lda label1+11*32,x
	sta $f48,x
smc13	lda label1+12*32,x
	sta $f70,x
smc14	lda label1+13*32,x
	sta $f98,x
smc15	lda label1+14*32,x
	sta $fc0,x
	dex
	bpl loop01
	jsr waitF0
	rts
;-------------------------------------------------------
; this controls the update function and makes it sweep
; back and forth the 15 animation phases of the waving
controlCopyUpdate
	lda ddir
	bne decpath
	inc dsrc
	ldx #14
	cpx dsrc
	bne notover
	dex
	stx dsrc
	stx ddir
	bne notover
decpath	dec dsrc
	bpl notunder
	ldx #0
	stx ddir
	inx
	stx dsrc
notunder	
notover	rts
;-------------------------------------------------------
; this updates the source pointers where the copy func-
; tion takes the data from
updateCopyWave
	ldx dsrc
	lda table1l,x
	sta addy_l
	lda table1h,x
	sta addy_h
	lda addy_l
	sta smc01+1
	lda addy_h
	sta smc01+2
	lda addy_l
	clc
	adc #32
	sta addy_l
	lda addy_h
	adc #0
	sta addy_h
	lda addy_l
	sta smc02+1
	lda addy_h
	sta smc02+2
	lda addy_l
	clc
	adc #32
	sta addy_l
	lda addy_h
	adc #0
	sta addy_h
	lda addy_l
	sta smc03+1
	lda addy_h
	sta smc03+2
	lda addy_l
	clc
	adc #32
	sta addy_l
	lda addy_h
	adc #0
	sta addy_h
	lda addy_l
	sta smc04+1
	lda addy_h
	sta smc04+2
	lda addy_l
	clc
	adc #32
	sta addy_l
	lda addy_h
	adc #0
	sta addy_h
	lda addy_l
	sta smc05+1
	lda addy_h
	sta smc05+2
	lda addy_l
	clc
	adc #32
	sta addy_l
	lda addy_h
	adc #0
	sta addy_h
	lda addy_l
	sta smc06+1
	lda addy_h
	sta smc06+2
	lda addy_l
	clc
	adc #32
	sta addy_l
	lda addy_h
	adc #0
	sta addy_h
	lda addy_l
	sta smc07+1
	lda addy_h
	sta smc07+2
	lda addy_l
	clc
	adc #32
	sta addy_l
	lda addy_h
	adc #0
	sta addy_h
	lda addy_l
	sta smc08+1
	lda addy_h
	sta smc08+2
	lda addy_l
	clc
	adc #32
	sta addy_l
	lda addy_h
	adc #0
	sta addy_h
	lda addy_l
	sta smc09+1
	lda addy_h
	sta smc09+2
	lda addy_l
	clc
	adc #32
	sta addy_l
	lda addy_h
	adc #0
	sta addy_h
	lda addy_l
	sta smc10+1
	lda addy_h
	sta smc10+2
	lda addy_l
	clc
	adc #32
	sta addy_l
	lda addy_h
	adc #0
	sta addy_h
	lda addy_l
	sta smc11+1
	lda addy_h
	sta smc11+2
	lda addy_l
	clc
	adc #32
	sta addy_l
	lda addy_h
	adc #0
	sta addy_h
	lda addy_l
	sta smc12+1
	lda addy_h
	sta smc12+2
	lda addy_l
	clc
	adc #32
	sta addy_l
	lda addy_h
	adc #0
	sta addy_h
	lda addy_l
	sta smc13+1
	lda addy_h
	sta smc13+2
	lda addy_l
	clc
	adc #32
	sta addy_l
	lda addy_h
	adc #0
	sta addy_h
	lda addy_l
	sta smc14+1
	lda addy_h
	sta smc14+2
	lda addy_l
	clc
	adc #32
	sta addy_l
	lda addy_h
	adc #0
	sta addy_h
	lda addy_l
	sta smc15+1
	lda addy_h
	sta smc15+2
	rts
;-------------------------------------------------------
; this fills colour matrix from bottom to top with black
; via gray-scale gradient swipe
backgroundUpSwipe
	ldy #39
loop02	lda #$51
smc_us1	sta $b70,y
	lda #$31
smc_us2	sta $b98,y
	lda #0
smc_us3	sta $bc0,y
	dey
	bpl loop02
	inc swipe_c
	lda #24
	cmp swipe_c
	bmi end_us
	ldx swipe_c
	lda table2l,x
	sta smc_us3+1
	lda table2h,x
	sta smc_us3+2
	inx
	lda table2l,x
	sta smc_us2+1
	lda table2h,x
	sta smc_us2+2
	inx
	lda table2l,x
	sta smc_us1+1
	lda table2h,x
	sta smc_us1+2
	ldx ten
	jsr waitF0
	dex
	bne *-4
	jmp backgroundUpSwipe
end_us	rts
;-------------------------------------------------------
; this fills colour matrix from top to bottom with white
; via gray-scale gradient swipe
backgroundDownSwipe
	ldy #39
loop03	lda #$31
smc_ds1	sta $850,y
	lda #$51
smc_ds2	sta $828,y
	lda #$71
smc_ds3	sta $800,y
	dey
	bpl loop03
	inc swipe_c
	lda #24
	cmp swipe_c
	bmi end_ds
	ldx swipe_c
	lda table3l,x
	sta smc_ds3+1
	lda table3h,x
	sta smc_ds3+2
	inx
	lda table3l,x
	sta smc_ds2+1
	lda table3h,x
	sta smc_ds2+2
	inx
	lda table3l,x
	sta smc_ds1+1
	lda table3h,x
	sta smc_ds1+2
	ldx ten
	jsr waitF0
	dex
	bne *-4
	jmp backgroundDownSwipe
end_ds	rts
;-------------------------------------------------------
; this scrolls the introduction text at the top of the
; default screen
scrollIntroduction
	ldy #0
	ldx scroll
loop04	lda scroll_t+0*120,x
	sta $c00,y
	lda scroll_t+1*120,x
	sta $c28,y
	lda scroll_t+2*120,x
	sta $c50,y
	lda scroll_t+3*120,x
	sta $c78,y
	lda scroll_t+4*120,x
	sta $ca0,y
	lda scroll_t+5*120,x
	sta $cc8,y
	inx
	iny
	cpy #40
	bne loop04
	rts
;-------------------------------------------------------
; this updates and controls the introduction text scroll
updateScroll
	lda #120
	cmp scroll
	beq end_usc
	inc scroll
	rts
end_usc	inc scrostp
	rts
;-------------------------------------------------------
; interrupt handler for playing digitized speech
irq	pha
	tya
	pha
	asl $ff09
phase	ldy speech1
	sty $ff11
	inc phase+1
	bne chk_end
	inc phase+2
chk_end	lda #lo(speech1end)
	cmp phase+1
	bne endirq
chk_en2	lda #hi(speech1end)
	cmp phase+2
	bne endirq
	lda #$4c	; stopping replay
	sta phase
	lda #lo(endirq)
	sta phase+1
	lda #hi(endirq)
	sta phase+2
	inc digistp
endirq	pla
	tay
	pla
	rti
;-------------------------------------------------------
; this reprograms the interrupt handler to play the
; second digitized speech
irqReprogram
	sei
	asl $ff09
	lda #lo(speech2)
	sta phase+1
	lda #hi(speech2)
	sta phase+2
	lda #lo(speech2end)
	sta chk_end+1
	lda #hi(speech2end)
	sta chk_en2+1
	lda #0
	sta digistp
	lda #$ac	; restart replay
	sta phase
	cli
	rts
;-------------------------------------------------------
; this copies the vertical CD5 logo to the right by inc-
; rementing the characters by one until they match the
; value in the given position
copyLogoData
	ldy #6
loop05	lda cd5+ 0*7,y
	sta $d18+32,y
	lda cd5+ 1*7,y
	sta $d40+32,y
	lda cd5+ 2*7,y
	sta $d68+32,y
	lda cd5+ 3*7,y
	sta $d90+32,y
	lda cd5+ 4*7,y
	sta $db8+32,y
	lda cd5+ 5*7,y
	sta $de0+32,y
	lda cd5+ 6*7,y
	sta $e08+32,y
	lda cd5+ 7*7,y
	sta $e30+32,y
	lda cd5+ 8*7,y
	sta $e58+32,y
	lda cd5+ 9*7,y
	sta $e80+32,y
	lda cd5+10*7,y
	sta $ea8+32,y
	lda cd5+11*7,y
	sta $ed0+32,y
	lda cd5+12*7,y
	sta $ef8+32,y
	lda cd5+13*7,y
	sta $f20+32,y
	lda cd5+14*7,y
	sta $f48+32,y
	lda cd5+15*7,y
	sta $f70+32,y
	lda cd5+16*7,y
	sta $f98+32,y
	dey
	bpl loop05
	rts
;-------------------------------------------------------
; this fills character matrix from bottom to top with
; black via gray-scale gradient swipe
characterUpSwipe
	ldy #39
loop07	lda #$55
smc_cs1	sta $f70,y
	lda #$aa
smc_cs2	sta $f98,y
	lda #$ff
smc_cs3	sta $fc0,y
	dey
	bpl loop07
	inc swipe_c
	lda #24
	cmp swipe_c
	bmi end_cus
	ldx swipe_c
	lda table2l,x
	sta smc_cs3+1
	lda table4h,x
	sta smc_cs3+2
	inx
	lda table2l,x
	sta smc_cs2+1
	lda table4h,x
	sta smc_cs2+2
	inx
	lda table2l,x
	sta smc_cs1+1
	lda table4h,x
	sta smc_cs1+2
	ldx ten
	jsr waitF0
	dex
	bne *-4
	jmp characterUpSwipe
end_cus	rts
;-------------------------------------------------------
; this fills character matrix from top to bottom with
; black via gray-scale gradient swipe
characterDownSwipe
	ldy #39
loop08	lda #$aa
smc_cs4	sta $c50,y
	lda #$55
smc_cs5	sta $c28,y
	lda #$00
smc_cs6	sta $c00,y
	dey
	bpl loop08
	inc swipe_c
	lda #24
	cmp swipe_c
	bmi end_cds
	ldx swipe_c
	lda table3l,x
	sta smc_cs6+1
	lda table5h,x
	sta smc_cs6+2
	inx
	lda table3l,x
	sta smc_cs5+1
	lda table5h,x
	sta smc_cs5+2
	inx
	lda table3l,x
	sta smc_cs4+1
	lda table5h,x
	sta smc_cs4+2
	ldx ten
	jsr waitF0
	dex
	bne *-4
	jmp characterDownSwipe
end_cds	rts
;-------------------------------------------------------
; this fills the graphic screen and colour matrix line
; by line with the "official" CD5 logo in a mixed order
paintLogoLines
	ldx #0
loop09	ldy table9,x
	jsr paintLogoColours
	jsr paintLogoBitmap
	ldy ten
loop10	jsr waitF0
	dey
	bne loop10
	inx
	cpx #table9end-table9
	bne loop09
	rts
;-------------------------------------------------------
; this copies the colour content of the logo's one line
paintLogoColours
	lda table3l,y
	sta smc_lc1+1
	sta smc_lc2+1
	sta smc_lc3+1
	sta smc_lc4+1
	lda table6h,y
	sta smc_lc1+2
	clc
	adc #4
	sta smc_lc3+2
	lda table3h,y
	sta smc_lc2+2
	clc
	adc #4
	sta smc_lc4+2
	stx smc_lc5+1
	ldx #39
loop11
smc_lc1	lda $555,x
smc_lc2	sta $ddd,x
smc_lc3	lda $555,x
smc_lc4	sta $ddd,x
	dex
	bpl loop11
smc_lc5	ldx #0
	rts
;-------------------------------------------------------
; this copies the bitmap content of the logo's one line
paintLogoBitmap
	lda table7l,y
	sta smc_lb1+1
	sta smc_lb2+1
	sta smc_lb3+1
	sta smc_lb4+1
	lda table7h,y
	sta smc_lb1+2
	sta smc_lb3+2
	inc smc_lb3+2
	lda table8h,y
	sta smc_lb2+2
	sta smc_lb4+2
	inc smc_lb4+2
	stx smc_lb5+1
	ldx #0
loop12
smc_lb1	lda $5555,x
smc_lb2	sta $dddd,x
	inx
	bne loop12
	ldx #319-256
loop13
smc_lb3	lda $5555,x
smc_lb4	sta $dddd,x
	dex
	bpl loop13
smc_lb5	ldx #0
	rts
;-------------------------------------------------------
; this fills the graphic screen and colour matrix line
; by line with the "official" CD5 logo in a mixed order
clearLogoLines
	ldx #0
loop14	ldy table9,x

	lda table7l,y
	sta smc_cl1+1
	sta smc_cl2+1
	lda table8h,y
	sta smc_cl1+2
	sta smc_cl2+2
	inc smc_cl2+2
	stx smc_cl3+1
	lda #0
	tax
loop15
smc_cl1	sta $dddd,x
	inx
	bne loop15
	ldx #319-256
loop16
smc_cl2	sta $dddd,x
	dex
	bpl loop16
smc_cl3	ldx #0
	ldy ten
loop17	jsr waitF0
	dey
	bne loop17
	inx
	cpx #table9end-table9
	bne loop14
	rts
;-------------------------------------------------------
; second interrupt handler for "official" logo sounds
irq2	pha
	txa
	pha
	tya
	pha
	asl $ff09
dur1	lda #0
	beq ch1
	dec dur1+1
	jmp dur2
ch1	ldx #0
	cpx #ch1dur-ch1frq
	beq dur2
dur01	lda ch1dur,x
	sta dur1+1
	lda ch1frq,x
	asl a
	tay
frq01	lda $5555,y
	sta $ff0e
	iny
	lda $ff12
	and #%11111100
frq02	ora $5555,y
	sta $ff12
next1	inx
	stx ch1+1
dur2	lda #0
	beq ch2
	dec dur2+1
	jmp end_ir2
ch2	ldx #0
	cpx #ch2dur-ch2frq
	beq quitirq	; channel 2 controls length!!!
dur02	lda ch2dur,x
	sta dur2+1
	lda ch2frq,x
	asl a
	tay
frq03	lda $5555,y
	sta $ff0f
	iny
frq04	lda $5555,y
	sta $ff10
next2	inx
	stx ch2+1
	bne end_ir2
quitirq	lda #0
	sta $ff11
	lda #$4c
	sta dur1
	lda #lo(end_ir2)
	sta dur1+1
	lda #hi(end_ir2)
	sta dur1+2
end_ir2	pla
	tay
	pla
	tax
	pla
	rti

ch1frq
	db 13, 14, 15, 16, 17, 18, 19, 20
	db  0, 62, 0, 62, 0, 62, 0, 62, 0, 62, 0
	; notes below are the generous donation
	; of Csabo/Legion of Doom
        db 13, 16, 20, 25
        db 20, 25, 28, 32
        db 25, 28, 32, 35
        db  0
        db 28,  0, 32,  0, 35,  0, 37
ch1dur
	db 4, 4, 4, 4, 4, 4, 4, 4
	db 4, 14, 4, 14, 4, 14, 4, 14, 4, 14, 0
	; durations below belong to the donated
	; notes
        db  3,  3,  3,  3
        db  4,  4,  4,  4
        db  5,  5,  5,  5
        db 12
        db  7,  1,  7,  1,  7,  1, 48
ch2frq
	db  0, 1, 0, 7, 0, 2, 0, 8, 0, 3, 0, 9, 0, 4, 0, 10
	db  0
	; notes below are the generous donation
	; of Csabo/Legion of Doom
        db  8,  8,  8,  8
        db  6,  6,  6,  6
        db  4,  4,  4,  4
        db  0
        db  4,  0,  3,  0,  4,  0,  1
ch2dur
	db  0, 3, 0, 3, 0, 3, 0, 3, 0, 3, 0, 3, 0, 3, 0, 3
	db 101
	; durations below belong to the donated
	; notes
        db  3,  3,  3,  3
        db  4,  4,  4,  4
        db  5,  5,  5,  5
        db 12
        db  7,  1,  7,  1,  7,  1, 48
palfrq	dw $3fe
	dw  15,  72, 125, 176, 223, 268, 311, 350
	dw 388, 424, 457, 489, 519, 547, 574, 600
	dw 623, 646, 667, 687, 705, 723, 740, 756
	dw 771, 785, 799, 811, 823, 834, 845, 855
	dw 864, 873, 882, 890, 897, 904, 911, 917
	dw 923, 929, 934, 939, 944, 948, 952, 956
	dw 960, 964, 967, 970, 973, 976, 978, 981
	dw 983, 986, 988, 990, 992, 1023
ntscfrq	dw $3fe
	dw   6,  63, 117, 168, 216, 261, 304, 344
	dw 382, 418, 452, 484, 515, 543, 570, 595
	dw 619, 642, 663, 684, 703, 721, 738, 754
	dw 769, 783, 797, 809, 821, 833, 843, 853
	dw 863, 872, 880, 888, 896, 903, 910, 916
	dw 922, 928, 933, 938, 943, 947, 952, 956
	dw 959, 963, 966, 970, 973, 975, 978, 981
	dw 983, 985, 987, 989, 991, 1023
frqend

table1l	; wave phases address low byte
	db lo(label1) , lo(label2) , lo(label3) , lo(label4)
	db lo(label5) , lo(label6) , lo(label7) , lo(label8)
	db lo(label9) , lo(label10), lo(label11), lo(label12)
	db lo(label13), lo(label14), lo(label15)
table1h	; wave phases address high byte
	db hi(label1) , hi(label2) , hi(label3) , hi(label4)
	db hi(label5) , hi(label6) , hi(label7) , hi(label8)
	db hi(label9) , hi(label10), hi(label11), hi(label12)
	db hi(label13), hi(label14), hi(label15)

table2l	; default colour matrix line starts low byte
	; in reverse order
	db $c0, $98, $70, $48, $20, $f8, $d0, $a8
	db $80, $58, $30, $08, $e0, $b8, $90, $68
	db $40, $18, $f0, $c8, $a0, $78, $50, $28
	db $00, $00, $00
table2h	; default colour matrix line starts high byte
	; in reverse order
	db $0b, $0b, $0b, $0b, $0b, $0a, $0a, $0a
	db $0a, $0a, $0a, $0a, $09, $09, $09, $09
	db $09, $09, $08, $08, $08, $08, $08, $08
	db $08, $08, $08

table3l	; default colour matrix line starts low byte
	db $00, $28, $50, $78, $a0, $c8, $f0, $18
	db $40, $68, $90, $b8, $e0, $08, $30, $58
	db $80, $a8, $d0, $f8, $20, $48, $70, $98
	db $c0, $c0, $c0
table3h	; default colour matrix line starts high byte
	db $08, $08, $08, $08, $08, $08, $08, $09
	db $09, $09, $09, $09, $09, $0a, $0a, $0a
	db $0a, $0a, $0a, $0a, $0b, $0b, $0b, $0b
	db $0b, $0b, $0b

table4h	; default character matrix line starts high byte
	db $0f, $0f, $0f, $0f, $0f, $0e, $0e, $0e
	db $0e, $0e, $0e, $0e, $0d, $0d, $0d, $0d
	db $0d, $0d, $0c, $0c, $0c, $0c, $0c, $0c
	db $0c, $0c, $0c

; table5l'd be the same as table3l
table5h	; default character matrix line starts high byte
	; in reverse order
	db $0c, $0c, $0c, $0c, $0c, $0c, $0c, $0d
	db $0d, $0d, $0d, $0d, $0d, $0e, $0e, $0e
	db $0e, $0e, $0e, $0e, $0f, $0f, $0f, $0f
	db $0f, $0f, $0f

; table6l'd be the same as table3l
table6h	; logo colourmatrix source line starts high byte
	db hi(colourmatrix+ 0*40), hi(colourmatrix+ 1*40), hi(colourmatrix+ 2*40), hi(colourmatrix+ 3*40)
	db hi(colourmatrix+ 4*40), hi(colourmatrix+ 5*40), hi(colourmatrix+ 6*40), hi(colourmatrix+ 7*40)
	db hi(colourmatrix+ 8*40), hi(colourmatrix+ 9*40), hi(colourmatrix+10*40), hi(colourmatrix+11*40)
	db hi(colourmatrix+12*40), hi(colourmatrix+13*40), hi(colourmatrix+14*40), hi(colourmatrix+15*40)
	db hi(colourmatrix+16*40), hi(colourmatrix+17*40), hi(colourmatrix+18*40), hi(colourmatrix+19*40)
	db hi(colourmatrix+20*40), hi(colourmatrix+21*40), hi(colourmatrix+22*40), hi(colourmatrix+23*40)
	db hi(colourmatrix+24*40)

table7l
	db lo(bitmap+ 0*320), lo(bitmap+ 1*320), lo(bitmap+ 2*320), lo(bitmap+ 3*320), lo(bitmap+ 4*320)
	db lo(bitmap+ 5*320), lo(bitmap+ 6*320), lo(bitmap+ 7*320), lo(bitmap+ 8*320), lo(bitmap+ 9*320)
	db lo(bitmap+10*320), lo(bitmap+11*320), lo(bitmap+12*320), lo(bitmap+13*320), lo(bitmap+14*320)
	db lo(bitmap+15*320), lo(bitmap+16*320), lo(bitmap+17*320), lo(bitmap+18*320), lo(bitmap+19*320)
	db lo(bitmap+20*320), lo(bitmap+21*320), lo(bitmap+22*320), lo(bitmap+23*320), lo(bitmap+24*320)
table7h
	db hi(bitmap+ 0*320), hi(bitmap+ 1*320), hi(bitmap+ 2*320), hi(bitmap+ 3*320), hi(bitmap+ 4*320)
	db hi(bitmap+ 5*320), hi(bitmap+ 6*320), hi(bitmap+ 7*320), hi(bitmap+ 8*320), hi(bitmap+ 9*320)
	db hi(bitmap+10*320), hi(bitmap+11*320), hi(bitmap+12*320), hi(bitmap+13*320), hi(bitmap+14*320)
	db hi(bitmap+15*320), hi(bitmap+16*320), hi(bitmap+17*320), hi(bitmap+18*320), hi(bitmap+19*320)
	db hi(bitmap+20*320), hi(bitmap+21*320), hi(bitmap+22*320), hi(bitmap+23*320), hi(bitmap+24*320)

; table8l'd be the same as table7l
table8h
	db hi(bmpdst+ 0*320), hi(bmpdst+ 1*320), hi(bmpdst+ 2*320), hi(bmpdst+ 3*320), hi(bmpdst+ 4*320)
	db hi(bmpdst+ 5*320), hi(bmpdst+ 6*320), hi(bmpdst+ 7*320), hi(bmpdst+ 8*320), hi(bmpdst+ 9*320)
	db hi(bmpdst+10*320), hi(bmpdst+11*320), hi(bmpdst+12*320), hi(bmpdst+13*320), hi(bmpdst+14*320)
	db hi(bmpdst+15*320), hi(bmpdst+16*320), hi(bmpdst+17*320), hi(bmpdst+18*320), hi(bmpdst+19*320)
	db hi(bmpdst+20*320), hi(bmpdst+21*320), hi(bmpdst+22*320), hi(bmpdst+23*320), hi(bmpdst+24*320)

table9	; line order for painting logo
	db 12, 11, 13, 10, 14,  9, 15,  8, 16,  7, 17, 6, 18, 5, 19;, 4, 20
table9end

;-------------------------------------------------------
; copy of KERNAL routine @ $F30B, $ff19 value set to $00
F30B	lda #$f
	sta 0
	lda #8
	sta 1
	ldx #$ff
	stx $fd10
	stx $fef3
	inx
	stx $fef4
	stx $fef0
	lda #$40
	sta $fef5
	jsr $edea
	lda tedregs,x
	sta $ff00,x
	inx
	cpx #$1a
	bne *-9
	jmp $eb46

tedregs	; copy of TED register initialization data
	db $f1, $39, $00, $00, $00, $00, $1b, $08, $00, $00, $02, $cc, $00, $00, $00, $00
	db $00, $00, $04, $d0, $08, $71, $5b, $75, $77, $00
	; there's a little free space here
;-------------------------------------------------------
; checking TV system, modding $FF07 init value
chkTV	lda $ff80	; PAL/NTSC detection from ROM
	sta ntsc	; version identifier
	bmi pal_sys
	lda #$48
	db $2c		; BIT skip
pal_sys	lda #8
	sta tedregs+7
	rts

	align 256
label1
	include "wave-001.asm"

label2
	include "wave-002.asm"

label3
	include "wave-003.asm"

label4
	include "wave-004.asm"

label5
	include "wave-005.asm"

label6
	include "wave-006.asm"

label7
	include "wave-007.asm"

label8
	include "wave-008.asm"

label9
	include "wave-009.asm"

label10
	include "wave-010.asm"

label11
	include "wave-011.asm"

label12
	include "wave-012.asm"

label13
	include "wave-013.asm"

label14
	include "wave-014.asm"

label15
	include "wave-015.asm"
	; there may be some free space here
	; probably around 128 bytes

	align 256
scroll_t
	include "scroll-t.asm"

cd5
	include "cd5.asm"
	; there's some large free space here

	align 2048
charset	
	include "charset.asm"

speech1
	include "GreetStart.asm"
speech1end

speech2
	include "GreetEnd.asm"
speech2end
	; there's some large free space here

	align 2048
colourmatrix
	include "cd5cmx.asm"

	align 8192
bitmap	
	include "cd5bmp.asm"

bmpdst	equ bitmap+8192

; additional files:
;
; wave-001.asm..wave-015.asm - hand waving animation phase data
; scroll-t.asm - upper scroll text data
; cd5.asm - data of CD5 "logo" in the right
; charset.asm - four level ordered dithering charset each
;               having four quadrants
; GreetStart.asm - 1st part of digitized Hungarian greetings
; GreetEnd.asm - 2nd part of digitized Hungarian greetings
;                                    (both 25 levels)
; cd5cmx.asm - colour matrix of CD5 "official" logo by
;              Csabo/LoD
; cd5bmp.asm - bitmap of CD5 "official" logo by Csabo/LoD